/* adv_utils.js
======================================================================
==   Sage++ (Higmmer's Edition)                                     ==
==     Copyright (C) Higmmer.NEeT / Higmmer All Rights Reserved.    ==
==     The original Sage is the work of The Sage Project.           ==
======================================================================
*/


var elemCache = {};
function $(id) {
	return elemCache[id] || (elemCache[id] = document.getElementById(id));
}

function $N(name) {
	return document.createElement(name);
}

function splitRegExp(regexp) {
	var str = (regexp instanceof RegExp) ? regexp.source.replace(/\\\//g, "/") : regexp;
	if(!str) return [];
	
	var s = 0, nest = 0, esc = false, result = [];
	for(var i = 0; i < str.length; i++){
		var ch = str.charAt(i);
		if(!esc){
			switch(ch){
			case "|":
				if(nest == 0){
					var r = str.substring(s, i);
					if(r.length > 0) result.push(r);
					s = i + 1;
				}
				break;
			case "(":
				nest++;
				break;
			case ")":
				nest--;
				break;
			case "\\":
				esc = true;
				break;
			}
		}
		else{
			esc = false;
		}
	}
	if(s < str.length) result.push(str.substring(s, str.length));
	return result;
}

function throw_FailToCreateData(reason) {
	throw "Fail to create Data - " + reason;
}

function throw_NotImplemented(method) {
	throw "" + method + " is not implemented";
}


/* End of File */
