// Totally rewritten by Higmmer

var elemCache = {};
function $(id) {
	return elemCache[id] || (elemCache[id] = document.getElementById(id));
}
var strRes = {
	getString: function(id) {
		return $("strRes").getString(id);
	}
};


var PrefsUI = {
	instantApply: false,
	sageFolderId: null,
	startupCheckTargetFolderId: null,
	autoCheckTargetFolderId: null,
	
	init: function() {
		this.instantApply = document.documentElement.instantApply;
		this.sageFolderId = _impl.getRootFolderId();
		this.startupCheckTargetFolderId = CommonFunc.getPrefValue(CommonFunc.AUTO_CHECK_STARTUP_TARGET, "str", this.sageFolderId);
		this.autoCheckTargetFolderId = CommonFunc.getPrefValue(CommonFunc.AUTO_CHECK_TARGET, "str", this.sageFolderId);
		this.setupKeyConfig("keyOpenSidebar");
		this.setupKeyConfig("keyFocusSidebar");
		
		if ($("label:installReadManager").value != "") $("label:installReadManager").style.display = "block";
		
		window.setTimeout(function(){
			PrefsUISub.buildSelectFolderMenupopup.call(PrefsUISub);
			PrefsUISub.buildSelectCheckTargetFolderMenupopup.call(PrefsUISub);
		}, 0);
	},
	accept: function() {
		this.applyFolderSettings();
		this.applyKeyConfig("keyOpenSidebar");
		this.applyKeyConfig("keyFocusSidebar");
	},
	cancel: function() {
	},
	selectFolder: function(aEvent) {
		this.sageFolderId = aEvent.target.value;
		var related = { pref:$("pref:showUpdatedFeedCount"), elem:$("checkbox:showUpdatedFeedCount") };
		if (this.sageFolderId != $("pref:folderId").valueFromPreferences) {
			related.pref.value = false;
			related.elem.disabled = true;
		} else {
			related.pref.value = related.pref.valueFromPreferences;
			related.elem.disabled = false;
		}
		related.pref.setElementValue(related.elem);
		PrefsUISub.buildSelectCheckTargetFolderMenupopup.call(PrefsUISub);
		if (this.instantApply) this.applyFolderSettings();
	},
	applyFolderSettings: function() {
		$("pref:folderId").valueFromPreferences = this.sageFolderId;
		$("pref:autoCheckFeeds.startup.target").valueFromPreferences = this.startupCheckTargetFolderId || this.sageFolderId;
		$("pref:autoCheckFeeds.target").valueFromPreferences = this.autoCheckTargetFolderId || this.sageFolderId;
	},
	readShowUpdatedFeedCount: function() {
		var enabled = $("pref:showUpdatedFeedCount").value;
		$("checkbox:hideNoupdatedFolders").disabled = !enabled;
		return enabled;
	},
	selectCheckTargetFolder: function(aEvent, aType) {
		this[aType + "CheckTargetFolderId"] = aEvent.target.value;
		if (this.instantApply) this.applyFolderSettings();
	},
	readAutoCheckFeedsStartup: function() {
		var enabled = /^(on|reserved)$/.test($("pref:autoCheckFeeds.startup").value);
		$("checkbox:autoCheckFeeds.startup.once").disabled = !enabled;
		$("menulist:selectStartupCheckTargetFolder").disabled = !enabled;
		return enabled;
	},
	readAutoCheckFeedsEnable: function() {
		var enabled = $("pref:autoCheckFeeds.enable").value;
		$("textbox:autoCheckFeeds.interval").disabled = $("menulist:selectAutoCheckTargetFolder").disabled = !enabled;
		return enabled;
	},
	readAutoUpdateEnable: function() {
		var enabled = $("pref:autoUpdate.enable").value;
		//$("textbox:autoUpdate.limit").disabled = $("checkbox:autoUpdate.unifyFeed").disabled = !enabled;
		//$("label:autoUpdate.limit").className = enabled ? "" : "disabled";
		return enabled;
	},
	updateCheckTimeoutChanged: function(aEvent) {
		var timeout = $('pref:updateCheck.timeout');
		timeout.value = aEvent.target.checked ? (timeout.valueFromPreferences || timeout.defaultValue): 0;
	},
	readUpdateCheckTimeout: function() {
		var timeout = Math.floor($('pref:updateCheck.timeout').value / 1000);
		$("checkbox:updateCheckTimeout").checked = Boolean(timeout > 0);
		return timeout;
	},
	readRenderFeeds: function() {
		var enabled = $("pref:renderFeeds").value;
		$("checkbox:allowHTMLTags").disabled = !enabled;
		return enabled;
	},
	readUserCssSelect: function() {
		var select = $("pref:userCss.select").value;
		$("filefield:userCss.path").disabled = $("button:userCssBrowse").disabled = Boolean(select != 2);
		return select;
	},
	readUserScriptEnable: function() {
		var enabled = $("pref:userScript.enable").value;
		$("filefield:userScript.path").disabled = $("button:userScriptBrowse").disabled = !enabled;
		return enabled;
	},
	readUserFilePath: function(aName) {
		var file = $("pref:" + aName + ".path").value;
		var field = $("filefield:" + aName + ".path");
		field.file = file;
		field.label = file ? file.path : "";
	},
	browseUserFile: function(aName) {
		var pref = $("pref:" + aName + ".path");
		var lastFile = pref.value;
		var fileInfo = PrefsUISub.getFileInfo(aName);
		var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(Components.interfaces.nsIFilePicker);
		switch (fileInfo.filter) {
		case "*.folder":
			fp.init(window, fileInfo.winTitle, fp.modeGetFolder);
			if (lastFile) fp.displayDirectory = lastFile;
			break;
		default:
			fp.init(window, fileInfo.winTitle, fp.modeOpen);
			fp.appendFilter(fileInfo.filterTitle, fileInfo.filter);
			fp.appendFilters(fp.filterAll);
			if (lastFile && lastFile.parent) fp.displayDirectory = lastFile.parent;
		}
		if (fp.show() == fp.returnOK) pref.value = fp.file;
	},
	showAdvancedSettings: function() {
		window.openDialog("chrome://sagepp/content/dialogs/settings/advanced/adv_settings.xul", "sagepp_advanced_settings", "chrome,modal,centerscreen");
	},
	readRenderFeedsFolderDefault: function() {
		var useDefault = $("pref:outputFolder.default").value;
		$("filefield:outputFolder.path").disabled = $("button:outputFolderBrowse").disabled = useDefault;
	},
	readRenderFeedsCache: function() {
		var useCache = $("pref:renderFeeds.cache").value;
		$("textbox:renderFeeds.cache.expireDays").disabled = !useCache;
	},
	readKey: function(aName) {
		var keyPref = $("pref:" + aName);
		var key = keyPref.value;
		if (!/^[A-Z]$/.test(key)) keyPref.value = keyPref.defaultValue;
		return key;
	},
	setupKeyConfig: function(aName) {
		var modifiers = $("pref:" + aName + ".modifiers").value.toLowerCase().split(" ").forEach(function(key){
			if (key) $("checkbox:" + aName + "." + key).checked = true;
		});
	},
	changeKeyModifiers: function(aName) {
		if (this.instantApply) this.applyKeyConfig(aName);
	},
	applyKeyConfig: function(aName) {
		var modifiers = [];
		["shift", "control", "alt", "meta", "accel"].forEach(function(key){
			if ($("checkbox:" + aName + "." + key).checked) modifiers.push(key);
		});
		$("pref:" + aName + ".modifiers").valueFromPreferences = modifiers.join(" ");
	},
	showInstallReadManagerWizard: function() {
		PrefsUISub.openPage("http://himag.blog26.fc2.com/blog-entry-153.html");
	}
};


var PrefsUISub = {
	buildSelectFolderMenupopup: function() {
		var list = $("menulist:selectFolder");
		var popup = $("menupopup:selectFolder");
		var rootFolderId = PlacesUIUtils.allBookmarksFolderId;
		this.clearSelectFolderMenupopup(popup, rootFolderId, strRes.getString("bookmark_root_label"));
		this.fillFolder(popup, rootFolderId, 1, list, PrefsUI.sageFolderId);
		if (list.selectedIndex == -1) {
			list.selectedIndex = 0;
			PrefsUI.selectFolder({ target:{ value:rootFolderId } });
		}
	},
	buildSelectCheckTargetFolderMenupopup: function() {
		var listS = $("menulist:selectStartupCheckTargetFolder");
		var popupS = document.getElementById("menupopup:selectStartupCheckTargetFolder");
		var folder = PlacesUtils.getFolderContents(PrefsUI.sageFolderId, true).root;
		this.clearSelectFolderMenupopup(popupS, PrefsUI.sageFolderId, _impl.getTitle(folder));
		this.fillFolder(popupS, PrefsUI.sageFolderId, 1, listS, PrefsUI.startupCheckTargetFolderId)
		if(listS.selectedIndex == -1) {
			listS.selectedIndex = 0;
			PrefsUI.startupCheckTargetFolderId = PrefsUI.sageFolderId;
		}
		var listA = $("menulist:selectAutoCheckTargetFolder");
		var popupA = popupS.cloneNode(true);
		popupA.id = "";
		listA.replaceChild(popupA, listA.firstChild);
		for (var i = 0; i < popupA.childNodes.length; i++) {
			if(popupA.childNodes[i].value == PrefsUI.autoCheckTargetFolderId) listA.selectedIndex = i;
		}
		if(listA.selectedIndex == -1) {
			listA.selectedIndex = 0;
			PrefsUI.autoCheckTargetFolderId = PrefsUI.sageFolderId;
		}
	},
	clearSelectFolderMenupopup: function(aPopup, aRootFolderId, aRootLabel) {
		while (aPopup.hasChildNodes()) aPopup.removeChild(aPopup.firstChild);
		var menuitem = document.createElementNS(CommonFunc.XUL_NS, "menuitem");
		menuitem.setAttribute("label", aRootLabel);
		menuitem.setAttribute("value", aRootFolderId);
		aPopup.appendChild(menuitem);
	},
	fillFolder: function(aPopup, aFolderId, aDepth, aList, aCurrentFolderId) {
		var rootNode = PlacesUtils.getFolderContents(aFolderId).root;
		for (var i = 0; i < rootNode.childCount; i++) {
			var node = rootNode.getChild(i);
			if (PlacesUtils.nodeIsFolder(node) && !_impl.nodeIsLivemarkContainer(node)) {
				var aItemId = (node.type == Ci.nsINavHistoryResultNode.RESULT_TYPE_FOLDER_SHORTCUT) ? this.asQuery(node).folderItemId : node.itemId;
				var menuitem = document.createElementNS(CommonFunc.XUL_NS, "menuitem");
				var indentation = new Array(aDepth + 1).join("   ");
				menuitem.setAttribute("label", indentation + node.title);
				menuitem.setAttribute("value", aItemId);
				aPopup.appendChild(menuitem);
				if (aItemId == aCurrentFolderId) aList.selectedItem = menuitem;
				this.fillFolder(aPopup, aItemId, aDepth + 1, aList, aCurrentFolderId);
			}
		}
	},
	getFileInfo: function(aName) {
		var FI = function(resWinTitle, resFilterTitle, ext) {
			return {
				winTitle: strRes.getString(resWinTitle),
				filterTitle: resFilterTitle ? strRes.getString(resFilterTitle) + " (*." + ext + ")" : "",
				filter: "*." + ext
			};
		};
		var fileInfo = {
			userCss: FI("css_select_file", "css_css_file", "css"),
			userScript: FI("script_select_file", "script_script_file", "js"),
			outputFolder: FI("output_select_folder", "", "folder")
		};
		return fileInfo[aName];
	},
	openPage: function(aURL) {
		var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
		var win = wm.getMostRecentWindow("navigator:browser");
		if (win) {
			var browser = win.gBrowser;
			browser.selectedTab = browser.addTab(aURL, { ownerTab:browser.selectedTab, skipAnimation:true });
		} else {
			window.open(aURL);
		}
	},
	asQuery: function(aNode) {
		return aNode.QueryInterface(Components.interfaces.nsINavHistoryQueryResultNode);
	}
};
